import amsdal_glue as glue
from _typeshed import Incomplete
from amsdal_data.connections.constants import SECONDARY_PARTITION_KEY as SECONDARY_PARTITION_KEY
from amsdal_data.connections.db_alias_map import CONNECTION_BACKEND_ALIASES as CONNECTION_BACKEND_ALIASES
from amsdal_glue_core.common.interfaces.connection import ConnectionBase as ConnectionBase
from amsdal_utils.config.data_models.repository_config import RepositoryConfig as RepositoryConfig
from amsdal_utils.models.data_models.schema import ObjectSchema as ObjectSchema
from amsdal_utils.utils.singleton import Singleton
from typing import Any

class SchemaManagerBase: ...

class SchemaManagerHandler(metaclass=Singleton):
    _schema_manager: Incomplete
    def __init__(self) -> None: ...
    def set_schema_manager(self, schema_manager: SchemaManagerBase) -> None: ...
    def get_schema_manager(self) -> SchemaManagerBase: ...

def resolve_backend_class(backend: str) -> type[ConnectionBase]: ...
def get_schemas_for_connection_name(connection_name: str, repository_config: RepositoryConfig) -> list[str | None]: ...
def object_schema_to_glue_schema(object_schema: ObjectSchema, *, is_lakehouse_only: bool = False) -> glue.Schema: ...
def object_schema_type_to_glue_type(property_type: str) -> glue.Schema | glue.SchemaReference | type[Any]: ...
def is_reference_type(property_type: str) -> bool: ...
